package at.co.xss.test;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.enterprise.context.Conversation;
import javax.enterprise.context.ConversationScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.richfaces.component.UIDataTable;

@Named
@ConversationScoped
public class BackingBean implements Serializable
{
    private static final long serialVersionUID = 1553476202903730892L;

    private static final Log LOG = LogFactory.getLog(BackingBean.class);

    private List<Item> items = new ArrayList<>();
    
    /** the data table binding for the rich:dataTable */
    private UIDataTable dataTable;

    @Inject
    private Conversation conversation;

    @Inject
    public void init()
    {
        items.add(new Item(1L, "First", "The first item"));
        items.add(new Item(2L, "Second", "The second item"));
        items.add(new Item(3L, "Third", "The third item"));
        items.add(new Item(4L, "Fourth", "The fourth item"));
        
        initConversation();
        
        LOG.debug("BackingBean initialized, conversation=" + conversation);
        
    }
    
    public List<Item> getItems()
    {
        return items;
    }
    
    public UIDataTable getDataTable()
    {
        return dataTable;
    }
    
    public void setDataTable(UIDataTable binding)
    {
        dataTable = binding;
    }

    public void initConversation()
    {
        LOG.debug("initConversation()");
        
        if (!FacesContext.getCurrentInstance().isPostback() && conversation.isTransient()) {
            conversation.begin();
            
        }
    }
    
    public Conversation getConversation()
    {
        LOG.debug("getConversation(), res=" + conversation);

        return conversation;
    }
    
    public void endConversation() 
    {
        LOG.debug("endConversation()");

        if (!conversation.isTransient()){
            conversation.end();
        }
    }
}
